diff --git a/drivers/net/ethernet/3com/3c589_cs.c b/drivers/net/ethernet/3com/3c589_cs.c
index be58dac0502a..dc1f8ccca5ec 100644
--- a/drivers/net/ethernet/3com/3c589_cs.c
+++ b/drivers/net/ethernet/3com/3c589_cs.c
@@ -137,6 +137,8 @@ struct el3_private {
 	u16			fast_poll;
 	unsigned long		last_irq;
 	spinlock_t		lock;
+	u16			pending;
+	struct napi_struct	napi;
 };
 
 static const char *if_names[] = { "auto", "10baseT", "10base2", "AUI" };
@@ -176,6 +178,7 @@ static void el3_tx_timeout(struct net_device *dev, unsigned int txqueue);
 static void set_rx_mode(struct net_device *dev);
 static void set_multicast_list(struct net_device *dev);
 static const struct ethtool_ops netdev_ethtool_ops;
+static int el3_napi_poll(struct napi_struct *napi, int budget);
 
 static void tc589_detach(struct pcmcia_device *p_dev);
 
@@ -219,6 +222,8 @@ static int tc589_probe(struct pcmcia_device *link)
 
 	dev->ethtool_ops = &netdev_ethtool_ops;
 
+	netif_napi_add(dev, &lp->napi, el3_napi_poll);
+
 	ret = tc589_config(link);
 	if (ret)
 		goto err_free_netdev;
@@ -527,6 +532,8 @@ static int el3_open(struct net_device *dev)
 	timer_setup(&lp->media, media_check, 0);
 	mod_timer(&lp->media, jiffies + HZ);
 
+	napi_enable(&lp->napi);
+
 	dev_dbg(&link->dev, "%s: opened, status %4.4x.\n",
 	  dev->name, inw(dev->base_addr + EL3_STATUS));
 
@@ -547,10 +554,10 @@ static void el3_tx_timeout(struct net_device *dev, unsigned int txqueue)
 	netif_wake_queue(dev);
 }
 
-static void pop_tx_status(struct net_device *dev)
+static int pop_tx_status(struct net_device *dev)
 {
 	unsigned int ioaddr = dev->base_addr;
-	int i;
+	int i, work = 0;
 
 	/* Clear the Tx status stack. */
 	for (i = 32; i > 0; i--) {
@@ -566,7 +573,9 @@ static void pop_tx_status(struct net_device *dev)
 			dev->stats.tx_aborted_errors++;
 		}
 		outb(0x00, ioaddr + TX_STATUS); /* Pop the status stack. */
+		work++;
 	}
+	return work;
 }
 
 static netdev_tx_t el3_start_xmit(struct sk_buff *skb,
@@ -587,7 +596,11 @@ static netdev_tx_t el3_start_xmit(struct sk_buff *skb,
 	outw(skb->len, ioaddr + TX_FIFO);
 	outw(0x00, ioaddr + TX_FIFO);
 	/* ... and the packet rounded to a doubleword. */
+#if 0
 	outsl(ioaddr + TX_FIFO, skb->data, (skb->len + 3) >> 2);
+#else
+	outsw(ioaddr + TX_FIFO, skb->data, (skb->len + 3) >> 2 << 1);
+#endif
 
 	if (inw(ioaddr + TX_FREE) <= 1536) {
 		netif_stop_queue(dev);
@@ -602,47 +615,38 @@ static netdev_tx_t el3_start_xmit(struct sk_buff *skb,
 	return NETDEV_TX_OK;
 }
 
-/* The EL3 interrupt handler. */
-static irqreturn_t el3_interrupt(int irq, void *dev_id)
+static int el3_napi_handle(struct net_device *dev, int budget)
 {
-	struct net_device *dev = (struct net_device *) dev_id;
 	struct el3_private *lp = netdev_priv(dev);
-	unsigned int ioaddr;
+	unsigned int ioaddr = dev->base_addr;
 	__u16 status;
-	int i = 0, handled = 1;
-
-	if (!netif_device_present(dev))
-		return IRQ_NONE;
-
-	ioaddr = dev->base_addr;
-
-	netdev_dbg(dev, "interrupt, status %4.4x.\n", inw(ioaddr + EL3_STATUS));
+	int work = 0;
 
-	spin_lock(&lp->lock);
-	while ((status = inw(ioaddr + EL3_STATUS)) &
+	while ((status = (inw(ioaddr + EL3_STATUS) | lp->pending)) &
 	(IntLatch | RxComplete | StatsFull)) {
+		lp->pending = 0;
 		if ((status & 0xe000) != 0x2000) {
 			netdev_dbg(dev, "interrupt from dead card\n");
-			handled = 0;
-			break;
+			return 0;
 		}
 		if (status & RxComplete)
-			el3_rx(dev);
+			work += el3_rx(dev);
 		if (status & TxAvailable) {
 			netdev_dbg(dev, "    TX room bit was handled.\n");
 			/* There's room in the FIFO for a full-sized packet. */
 			outw(AckIntr | TxAvailable, ioaddr + EL3_CMD);
 			netif_wake_queue(dev);
+			work++;
 		}
 		if (status & TxComplete)
-			pop_tx_status(dev);
+			work += pop_tx_status(dev);
 		if (status & (AdapterFailure | RxEarly | StatsFull)) {
 			/* Handle all uncommon interrupts. */
 			if (status & StatsFull)		/* Empty statistics. */
 				update_stats(dev);
 			if (status & RxEarly) {
 				/* Rx early is unused. */
-				el3_rx(dev);
+				work += el3_rx(dev);
 				outw(AckIntr | RxEarly, ioaddr + EL3_CMD);
 			}
 			if (status & AdapterFailure) {
@@ -666,17 +670,74 @@ static irqreturn_t el3_interrupt(int irq, void *dev_id)
 				outw(AckIntr | AdapterFailure, ioaddr + EL3_CMD);
 			}
 		}
-		if (++i > 10) {
-			netdev_err(dev, "infinite loop in interrupt, status %4.4x.\n",
-					status);
-			/* Clear all interrupts */
-			outw(AckIntr | 0xFF, ioaddr + EL3_CMD);
-			break;
-		}
 		/* Acknowledge the IRQ. */
 		outw(AckIntr | IntReq | IntLatch, ioaddr + EL3_CMD);
 	}
 	lp->last_irq = jiffies;
+
+	return work;
+}
+
+static int el3_napi_poll(struct napi_struct *napi, int budget)
+{
+	struct net_device *dev = napi->dev;
+	struct el3_private *lp = netdev_priv(dev);
+	unsigned int ioaddr = dev->base_addr;
+	int work = 0;
+
+	if (!netif_running(dev)) {
+		napi_complete(napi);
+		return 0;
+	}
+
+	netdev_dbg(dev, "napi poll, status %4.4x.\n", inw(ioaddr + EL3_STATUS));
+
+	spin_lock(&lp->lock);
+	work = el3_napi_handle(dev, budget);
+	spin_unlock(&lp->lock);
+
+	netdev_dbg(dev, "exiting napi poll, status %4.4x.\n",
+			inw(ioaddr + EL3_STATUS));
+
+	budget -= work;
+	if (budget > 0) {
+		napi_complete(napi);
+		outw(SetIntrEnb | IntLatch | TxAvailable | RxComplete
+		 | StatsFull | AdapterFailure, ioaddr + EL3_CMD);
+	}
+
+	return work;
+}
+
+/* The EL3 interrupt handler. */
+static irqreturn_t el3_interrupt(int irq, void *dev_id)
+{
+	struct net_device *dev = (struct net_device *) dev_id;
+	struct el3_private *lp = netdev_priv(dev);
+	unsigned int ioaddr;
+	__u16 status;
+	int handled = 1;
+
+	if (!netif_device_present(dev))
+		return IRQ_NONE;
+
+	ioaddr = dev->base_addr;
+
+	netdev_dbg(dev, "interrupt, status %4.4x.\n", inw(ioaddr + EL3_STATUS));
+
+	spin_lock(&lp->lock);
+	status = inw(ioaddr + EL3_STATUS);
+	if ((status & 0xe000) != 0x2000) {
+		netdev_dbg(dev, "interrupt from dead card\n");
+		handled = 0;
+	} else {
+		lp->pending |= status;
+		outw(SetIntrEnb, ioaddr + EL3_CMD);
+		status &= IntLatch | TxAvailable | RxComplete
+		 | StatsFull | AdapterFailure;
+		outw(AckIntr | status, ioaddr + EL3_CMD);
+		napi_schedule(&lp->napi);
+	}
 	spin_unlock(&lp->lock);
 	netdev_dbg(dev, "exiting interrupt, status %4.4x.\n",
 			inw(ioaddr + EL3_STATUS));
@@ -867,8 +928,13 @@ static int el3_rx(struct net_device *dev)
 		       pkt_len, rx_status);
 			if (skb != NULL) {
 				skb_reserve(skb, 2);
+#if 0
 				insl(ioaddr+RX_FIFO, skb_put(skb, pkt_len),
 			(pkt_len+3)>>2);
+#else
+				insw(ioaddr+RX_FIFO, skb_put(skb, pkt_len),
+				     (pkt_len+3)>>2 << 1);
+#endif
 				skb->protocol = eth_type_trans(skb, dev);
 				netif_rx(skb);
 				dev->stats.rx_packets++;
@@ -884,7 +950,7 @@ static int el3_rx(struct net_device *dev)
 	}
 	if (worklimit == 0)
 		netdev_warn(dev, "too much work in el3_rx!\n");
-	return 0;
+	return 32 - worklimit;
 }
 
 static void set_rx_mode(struct net_device *dev)
@@ -944,6 +1010,8 @@ static int el3_close(struct net_device *dev)
 			update_stats(dev);
 	}
 
+	napi_disable(&lp->napi);
+
 	link->open--;
 	netif_stop_queue(dev);
 	del_timer_sync(&lp->media);
diff --git a/drivers/net/ethernet/smsc/smc91x.c b/drivers/net/ethernet/smsc/smc91x.c
index 907498848028..60dec9024c4e 100644
--- a/drivers/net/ethernet/smsc/smc91x.c
+++ b/drivers/net/ethernet/smsc/smc91x.c
@@ -62,6 +62,7 @@ static const char version[] =
 #include <linux/irq.h>
 #include <linux/errno.h>
 #include <linux/ioport.h>
+#include <linux/clk.h>
 #include <linux/crc32.h>
 #include <linux/platform_device.h>
 #include <linux/spinlock.h>
@@ -79,11 +80,6 @@ static const char version[] =
 
 #include "smc91x.h"
 
-#if defined(CONFIG_ASSABET_NEPONSET)
-#include <mach/assabet.h>
-#include <mach/neponset.h>
-#endif
-
 #ifndef SMC_NOWAIT
 # define SMC_NOWAIT		0
 #endif
@@ -2270,6 +2266,15 @@ static int smc_drv_probe(struct platform_device *pdev)
 		}
 	}
 
+	/*
+	 * Some platforms drive the xtal input from an external clock
+	 * source which may require some control.  Request the clock,
+	 * but allow probing to continue if no clock is specified.
+	 */
+	lp->xtal = devm_clk_get_optional(&pdev->dev, NULL);
+	if (IS_ERR(lp->xtal))
+		return PTR_ERR(lp->xtal);
+
 #if IS_BUILTIN(CONFIG_OF)
 	match = of_match_device(of_match_ptr(smc91x_match), &pdev->dev);
 	if (match) {
@@ -2362,19 +2367,20 @@ static int smc_drv_probe(struct platform_device *pdev)
 	ret = smc_request_attrib(pdev, ndev);
 	if (ret)
 		goto out_release_io;
-#if defined(CONFIG_ASSABET_NEPONSET)
-	if (machine_is_assabet() && machine_has_neponset())
-		neponset_ncr_set(NCR_ENET_OSC_EN);
-#endif
+	if (lp->xtal) {
+		ret = clk_prepare_enable(lp->xtal);
+		if (ret)
+			goto out_release_attrib;
+	}
 	platform_set_drvdata(pdev, ndev);
 	ret = smc_enable_device(pdev);
 	if (ret)
-		goto out_release_attrib;
+		goto out_disable_xtal;
 
 	addr = ioremap(res->start, SMC_IO_EXTENT);
 	if (!addr) {
 		ret = -ENOMEM;
-		goto out_release_attrib;
+		goto out_disable_xtal;
 	}
 
 #ifdef CONFIG_ARCH_PXA
@@ -2398,6 +2404,9 @@ static int smc_drv_probe(struct platform_device *pdev)
 	iounmap(addr);
  out_release_attrib:
 	smc_release_attrib(pdev, ndev);
+ out_disable_xtal:
+	if (lp->xtal)
+		clk_disable_unprepare(lp->xtal);
  out_release_io:
 	release_mem_region(res->start, SMC_IO_EXTENT);
  out_free_netdev:
@@ -2432,6 +2441,9 @@ static void smc_drv_remove(struct platform_device *pdev)
 		res = platform_get_resource(pdev, IORESOURCE_MEM, 0);
 	release_mem_region(res->start, SMC_IO_EXTENT);
 
+	if (lp->xtal)
+		clk_disable_unprepare(lp->xtal);
+
 	free_netdev(ndev);
 }
 
@@ -2441,9 +2453,14 @@ static int smc_drv_suspend(struct device *dev)
 
 	if (ndev) {
 		if (netif_running(ndev)) {
+			struct smc_local *lp = netdev_priv(ndev);
+
 			netif_device_detach(ndev);
 			smc_shutdown(ndev);
 			smc_phy_powerdown(ndev);
+
+			if (lp->xtal)
+				clk_disable_unprepare(lp->xtal);
 		}
 	}
 	return 0;
@@ -2456,6 +2473,11 @@ static int smc_drv_resume(struct device *dev)
 
 	if (ndev) {
 		struct smc_local *lp = netdev_priv(ndev);
+		if (lp->xtal) {
+			int ret = clk_prepare_enable(lp->xtal);
+			if (ret)
+				return ret;
+		}
 		smc_enable_device(pdev);
 		if (netif_running(ndev)) {
 			smc_reset(ndev);
diff --git a/drivers/net/ethernet/smsc/smc91x.h b/drivers/net/ethernet/smsc/smc91x.h
index 38aa4374e813..8eac2fa37f6e 100644
--- a/drivers/net/ethernet/smsc/smc91x.h
+++ b/drivers/net/ethernet/smsc/smc91x.h
@@ -205,6 +205,7 @@ struct smc_local {
 
 	struct gpio_desc *power_gpio;
 	struct gpio_desc *reset_gpio;
+	struct clk *xtal;
 
 	/* version/revision of the SMC91x chip */
 	int	version;
diff --git a/drivers/pcmcia/Makefile b/drivers/pcmcia/Makefile
index c9d51b150682..0fbed0d213ab 100644
--- a/drivers/pcmcia/Makefile
+++ b/drivers/pcmcia/Makefile
@@ -40,7 +40,7 @@ sa1111_cs-$(CONFIG_SA1100_JORNADA720)		+= sa1111_jornada720.o
 
 sa1100_cs-y					+= sa1100_generic.o
 sa1100_cs-$(CONFIG_SA1100_COLLIE)		+= pxa2xx_sharpsl.o
-sa1100_cs-$(CONFIG_SA1100_H3600)		+= sa1100_h3600.o
+sa1100_cs-$(CONFIG_SA1100_H3600)		+= sa1100_h3600.o l1110.o
 
 pxa2xx-obj-$(CONFIG_PXA_SHARPSL)		+= pxa2xx_sharpsl.o
 obj-$(CONFIG_PCMCIA_PXA2XX)			+= pxa2xx_base.o $(pxa2xx-obj-y)
diff --git a/drivers/pcmcia/l1110.c b/drivers/pcmcia/l1110.c
new file mode 100644
index 000000000000..67507019d3db
--- /dev/null
+++ b/drivers/pcmcia/l1110.c
@@ -0,0 +1,109 @@
+#include <linux/io.h>
+#include <linux/module.h>
+
+#include "l1110.h"
+#include "soc_common.h"
+
+enum {
+	PRS_S1 = BIT(0),
+	PRS_S2 = BIT(1),
+	PRS_S3 = BIT(2),
+	PRS_S4 = BIT(3),
+	PRS_BVD1 = BIT(4),
+	PRS_BVD2 = BIT(5),
+	PRS_VS1 = BIT(6),
+	PRS_VS2 = BIT(7),
+	PRS_RDY = BIT(8),
+	PRS_CD1 = BIT(9),
+	PRS_CD2 = BIT(10),
+
+	PRC_S1 = PRS_S1,	/* x1vcc - TPS2205 D2/D7 */
+	PRC_S2 = PRS_S2,	/* x0vcc - TPS2205 D3/D6 */
+	PRC_S3 = PRS_S3,	/* x0vpp - TPS2205 D1/D5 */
+	PRC_S4 = PRS_S4,	/* x1vpp - TPS2205 D0/D4 */
+	PRC_RST = BIT(4),
+	PRC_APOE = BIT(5), /* auto power off enable */
+	PRC_CFE = BIT(6), /* CF enable: A25:11 driven high */
+	PRC_SOE = BIT(7), /* signal output enable */
+	PRC_SSP = BIT(8), /* socket select polarity */
+};
+
+struct l1110 {
+	void __iomem *reg;
+	u16 prc;
+};
+
+int l1110_init(struct device *dev, struct l1110 **ptr, resource_size_t base,
+	unsigned int ssp)
+{
+	struct l1110 *l;
+
+	l = devm_kzalloc(dev, sizeof(*l), GFP_KERNEL);
+	if (!l)
+		return -ENOMEM;
+
+	l->prc = PRC_APOE | (ssp ? PRC_SSP : 0);
+	l->reg = devm_ioremap(dev, base, 2);
+	if (!l->reg)
+		return -ENOMEM;
+
+	*ptr = l;
+
+	writew_relaxed(l->prc, l->reg);
+
+	return 0;
+}
+EXPORT_SYMBOL_GPL(l1110_init);
+
+void l1110_socket_state(struct l1110 *l, struct pcmcia_state *state)
+{
+	u16 prs = readw_relaxed(l->reg);
+
+	state->bvd1 = !!(prs & PRS_BVD1);
+	state->bvd2 = !!(prs & PRS_BVD2);
+	state->vs_3v = !(prs & PRS_VS1);
+	state->vs_Xv = !(prs & PRS_VS2);
+}
+EXPORT_SYMBOL_GPL(l1110_socket_state);
+
+int l1110_configure_socket(struct l1110 *l, const socket_state_t *state)
+{
+	u16 prc = l->prc;
+
+	switch (state->Vcc) {
+	case 0:
+		break;
+	case 33:
+		prc |= PRC_S1;
+		break;
+	case 50:
+		prc |= PRC_S2;
+		break;
+	default:
+		return -EINVAL;
+	}
+
+	if (state->Vpp) {
+		if (state->Vpp == 12)
+			prc |= PRC_S4;
+		else if (state->Vpp == state->Vcc)
+			prc |= PRC_S3;
+		else
+			return -EINVAL;
+	}
+
+	if (state->flags & SS_RESET)
+		prc |= PRC_RST;
+
+	if (state->flags & SS_OUTPUT_ENA)
+		prc |= PRC_SOE;
+
+	writew_relaxed(prc, l->reg);
+
+	return 0;
+}
+EXPORT_SYMBOL_GPL(l1110_configure_socket);
+
+MODULE_AUTHOR("Russell King <rmk+kernel@armlinux.org.uk>");
+MODULE_DESCRIPTION("LinkUp Systems L1110 driver");
+MODULE_LICENSE("GPL");
diff --git a/drivers/pcmcia/l1110.h b/drivers/pcmcia/l1110.h
new file mode 100644
index 000000000000..2e404f64836a
--- /dev/null
+++ b/drivers/pcmcia/l1110.h
@@ -0,0 +1,15 @@
+#ifndef L1110_H
+#define L1110_H
+
+#include <linux/types.h>
+#include <pcmcia/ss.h>
+
+struct l1110;
+struct pcmcia_state;
+
+int l1110_init(struct device *dev, struct l1110 **ptr, resource_size_t base,
+	unsigned int ssp);
+void l1110_socket_state(struct l1110 *l, struct pcmcia_state *state);
+int l1110_configure_socket(struct l1110 *l, const socket_state_t *state);
+
+#endif
diff --git a/drivers/pcmcia/sa1100_h3600.c b/drivers/pcmcia/sa1100_h3600.c
index 10cb99c20a7f..8e25942010c6 100644
--- a/drivers/pcmcia/sa1100_h3600.c
+++ b/drivers/pcmcia/sa1100_h3600.c
@@ -5,23 +5,19 @@
  * PCMCIA implementation routines for H3600
  *
  */
-#include <linux/module.h>
 #include <linux/kernel.h>
 #include <linux/device.h>
-#include <linux/interrupt.h>
-#include <linux/init.h>
-#include <linux/delay.h>
-#include <linux/gpio.h>
+#include <linux/mod_devicetable.h>
 
-#include <mach/hardware.h>
-#include <asm/irq.h>
 #include <asm/mach-types.h>
-#include <mach/h3xxx.h>
 
+#include "l1110.h"
 #include "sa1100_generic.h"
 
-static int h3600_pcmcia_hw_init(struct soc_pcmcia_socket *skt)
+static int l1110_pcmcia_hw_init(struct soc_pcmcia_socket *skt)
 {
+	struct device *dev = skt->socket.dev.parent;
+	struct l1110 *l;
 	int err;
 
 	skt->stat[SOC_STAT_CD].name = skt->nr ? "pcmcia1-detect" : "pcmcia0-detect";
@@ -31,133 +27,48 @@ static int h3600_pcmcia_hw_init(struct soc_pcmcia_socket *skt)
 	if (err)
 		return err;
 
-	switch (skt->nr) {
-	case 0:
-		err = gpio_request(H3XXX_EGPIO_OPT_NVRAM_ON, "OPT NVRAM ON");
-		if (err)
-			goto err01;
-		err = gpio_direction_output(H3XXX_EGPIO_OPT_NVRAM_ON, 0);
-		if (err)
-			goto err03;
-		err = gpio_request(H3XXX_EGPIO_OPT_ON, "OPT ON");
-		if (err)
-			goto err03;
-		err = gpio_direction_output(H3XXX_EGPIO_OPT_ON, 0);
-		if (err)
-			goto err04;
-		err = gpio_request(H3XXX_EGPIO_OPT_RESET, "OPT RESET");
-		if (err)
-			goto err04;
-		err = gpio_direction_output(H3XXX_EGPIO_OPT_RESET, 0);
-		if (err)
-			goto err05;
-		err = gpio_request(H3XXX_EGPIO_CARD_RESET, "PCMCIA CARD RESET");
-		if (err)
-			goto err05;
-		err = gpio_direction_output(H3XXX_EGPIO_CARD_RESET, 0);
-		if (err)
-			goto err06;
-		break;
-	case 1:
-		break;
-	}
-	return 0;
-
-err06:	gpio_free(H3XXX_EGPIO_CARD_RESET);
-err05:	gpio_free(H3XXX_EGPIO_OPT_RESET);
-err04:	gpio_free(H3XXX_EGPIO_OPT_ON);
-err03:	gpio_free(H3XXX_EGPIO_OPT_NVRAM_ON);
-err01:	gpio_free(H3XXX_GPIO_PCMCIA_IRQ0);
-	return err;
-}
-
-static void h3600_pcmcia_hw_shutdown(struct soc_pcmcia_socket *skt)
-{
-	switch (skt->nr) {
-	case 0:
-		/* Disable CF bus: */
-		gpio_set_value(H3XXX_EGPIO_OPT_NVRAM_ON, 0);
-		gpio_set_value(H3XXX_EGPIO_OPT_ON, 0);
-		gpio_set_value(H3XXX_EGPIO_OPT_RESET, 1);
-
-		gpio_free(H3XXX_EGPIO_CARD_RESET);
-		gpio_free(H3XXX_EGPIO_OPT_RESET);
-		gpio_free(H3XXX_EGPIO_OPT_ON);
-		gpio_free(H3XXX_EGPIO_OPT_NVRAM_ON);
-		break;
-	case 1:
-		break;
-	}
-}
-
-static void
-h3600_pcmcia_socket_state(struct soc_pcmcia_socket *skt, struct pcmcia_state *state)
-{
-	state->bvd1 = 0;
-	state->bvd2 = 0;
-	state->vs_3v = 0;
-	state->vs_Xv = 0;
-}
-
-static int
-h3600_pcmcia_configure_socket(struct soc_pcmcia_socket *skt, const socket_state_t *state)
-{
-	if (state->Vcc != 0 && state->Vcc != 33 && state->Vcc != 50) {
-		printk(KERN_ERR "h3600_pcmcia: unrecognized Vcc %u.%uV\n",
-		       state->Vcc / 10, state->Vcc % 10);
-		return -1;
-	}
-
-	gpio_set_value(H3XXX_EGPIO_CARD_RESET, !!(state->flags & SS_RESET));
+	err = l1110_init(dev, &l, skt->nr ? 0x19000000 : 0x1a000000,
+			 skt->nr);
+	if (err)
+		return err;
 
-	/* Silently ignore Vpp, output enable, speaker enable. */
+	skt->socket.driver_data = l;
 
 	return 0;
 }
 
-static void h3600_pcmcia_socket_init(struct soc_pcmcia_socket *skt)
+static void l1110_pcmcia_socket_state(struct soc_pcmcia_socket *skt,
+	struct pcmcia_state *state)
 {
-	/* Enable CF bus: */
-	gpio_set_value(H3XXX_EGPIO_OPT_NVRAM_ON, 1);
-	gpio_set_value(H3XXX_EGPIO_OPT_ON, 1);
-	gpio_set_value(H3XXX_EGPIO_OPT_RESET, 0);
+	struct l1110 *l = skt->socket.driver_data;
 
-	msleep(10);
+	l1110_socket_state(l, state);
 }
 
-static void h3600_pcmcia_socket_suspend(struct soc_pcmcia_socket *skt)
+static int l1110_pcmcia_configure_socket(struct soc_pcmcia_socket *skt,
+	const socket_state_t *state)
 {
-	/*
-	 * FIXME:  This doesn't fit well.  We don't have the mechanism in
-	 * the generic PCMCIA layer to deal with the idea of two sockets
-	 * on one bus.  We rely on the cs.c behaviour shutting down
-	 * socket 0 then socket 1.
-	 */
-	if (skt->nr == 1) {
-		gpio_set_value(H3XXX_EGPIO_OPT_ON, 0);
-		gpio_set_value(H3XXX_EGPIO_OPT_NVRAM_ON, 0);
-		/* hmm, does this suck power? */
-		gpio_set_value(H3XXX_EGPIO_OPT_RESET, 1);
-	}
+	struct l1110 *l = skt->socket.driver_data;
+
+	return l1110_configure_socket(l, state);
 }
 
-struct pcmcia_low_level h3600_pcmcia_ops = { 
+static struct pcmcia_low_level l1110_pcmcia_ops = {
 	.owner			= THIS_MODULE,
-	.hw_init		= h3600_pcmcia_hw_init,
-	.hw_shutdown		= h3600_pcmcia_hw_shutdown,
-	.socket_state		= h3600_pcmcia_socket_state,
-	.configure_socket	= h3600_pcmcia_configure_socket,
-
-	.socket_init		= h3600_pcmcia_socket_init,
-	.socket_suspend		= h3600_pcmcia_socket_suspend,
+	.hw_init		= l1110_pcmcia_hw_init,
+	.socket_state		= l1110_pcmcia_socket_state,
+	.configure_socket	= l1110_pcmcia_configure_socket,
 };
 
 int pcmcia_h3600_init(struct device *dev)
 {
-	int ret = -ENODEV;
+	struct ipaq_option_id *id = dev->platform_data;
+
+	if (!machine_is_h3600() || !id)
+		return -ENODEV;
 
-	if (machine_is_h3600())
-		ret = sa11xx_drv_pcmcia_probe(dev, &h3600_pcmcia_ops, 0, 2);
+	if (id->vendor != 0x1125 || id->device != 0x0001)
+		return -ENODEV;
 
-	return ret;
+	return sa11xx_drv_pcmcia_probe(dev, &l1110_pcmcia_ops, 0, 2);
 }
diff --git a/drivers/tty/serial/sa1100.c b/drivers/tty/serial/sa1100.c
index 79c794fa6545..77671d589f57 100644
--- a/drivers/tty/serial/sa1100.c
+++ b/drivers/tty/serial/sa1100.c
@@ -8,6 +8,8 @@
  */
 
 #include <linux/module.h>
+#include <linux/clk.h>
+#include <linux/gpio/consumer.h>
 #include <linux/ioport.h>
 #include <linux/init.h>
 #include <linux/console.h>
@@ -75,7 +77,10 @@ struct sa1100_port {
 	struct uart_port	port;
 	struct timer_list	timer;
 	unsigned int		old_status;
+	struct clk		*clk;
 	struct mctrl_gpios	*gpios;
+	struct gpio_desc	*xcvr_enable;
+	unsigned		wake;
 };
 
 /*
@@ -337,13 +342,19 @@ static int sa1100_startup(struct uart_port *port)
 		container_of(port, struct sa1100_port, port);
 	int retval;
 
+	retval = clk_prepare_enable(sport->clk);
+	if (retval)
+		return retval;
+
 	/*
 	 * Allocate the IRQ
 	 */
 	retval = request_irq(sport->port.irq, sa1100_int, 0,
 			     "sa11x0-uart", sport);
-	if (retval)
+	if (retval) {
+		clk_disable_unprepare(sport->clk);
 		return retval;
+	}
 
 	/*
 	 * Finally, clear and enable interrupts
@@ -380,6 +391,8 @@ static void sa1100_shutdown(struct uart_port *port)
 	 * Disable all interrupts, port and break condition.
 	 */
 	UART_PUT_UTCR3(sport, 0);
+
+	clk_disable_unprepare(sport->clk);
 }
 
 static void
@@ -561,6 +574,16 @@ sa1100_verify_port(struct uart_port *port, struct serial_struct *ser)
 	return ret;
 }
 
+static void sa1100_pm(struct uart_port *port, unsigned int state,
+	unsigned int old)
+{
+	struct sa1100_port *sport =
+		container_of(port, struct sa1100_port, port);
+
+	if (sport->xcvr_enable)
+		gpiod_direction_output(sport->xcvr_enable, !state);
+}
+
 static struct uart_ops sa1100_pops = {
 	.tx_empty	= sa1100_tx_empty,
 	.set_mctrl	= sa1100_set_mctrl,
@@ -578,6 +601,7 @@ static struct uart_ops sa1100_pops = {
 	.request_port	= sa1100_request_port,
 	.config_port	= sa1100_config_port,
 	.verify_port	= sa1100_verify_port,
+	.pm		= sa1100_pm,
 };
 
 static struct sa1100_port sa1100_ports[NR_PORTS];
@@ -620,18 +644,19 @@ static void __init sa1100_init_ports(void)
 	PPSR |= PPC_TXD1 | PPC_TXD3;
 }
 
-void sa1100_register_uart_fns(struct sa1100_port_fns *fns)
+void sa1100_register_uart_fns(const struct sa1100_port_fns *fns)
 {
+	unsigned int i;
+
 	if (fns->get_mctrl)
 		sa1100_pops.get_mctrl = fns->get_mctrl;
 	if (fns->set_mctrl)
 		sa1100_pops.set_mctrl = fns->set_mctrl;
 
 	sa1100_pops.pm       = fns->pm;
-	/*
-	 * FIXME: fns->set_wake is unused - this should be called from
-	 * the suspend() callback if device_may_wakeup(dev)) is set.
-	 */
+
+	for (i = 0; i < NR_PORTS; i++)
+		sa1100_ports[i].wake = fns->wake[i];
 }
 
 void __init sa1100_register_uart(int idx, int port)
@@ -804,19 +829,83 @@ static struct uart_driver sa1100_reg = {
 	.cons			= SA1100_CONSOLE,
 };
 
+static unsigned int sa1100_translate_mctrl_wake_mask(unsigned int wake_bits)
+{
+	unsigned int wake = 0;
+
+	if (wake_bits & SA11X0_WAKE_CTS)
+		wake |= BIT(UART_GPIO_CTS);
+	if (wake_bits & SA11X0_WAKE_DCD)
+		wake |= BIT(UART_GPIO_DCD);
+	if (wake_bits & SA11X0_WAKE_DSR)
+		wake |= BIT(UART_GPIO_DSR);
+	if (wake_bits & SA11X0_WAKE_RI)
+		wake |= BIT(UART_GPIO_RI);
+
+	return wake;
+}
+
 static int sa1100_serial_suspend(struct platform_device *dev, pm_message_t state)
 {
 	struct sa1100_port *sport = platform_get_drvdata(dev);
+	unsigned int i, enabled = 0, wake;
+	int ret;
+
+	wake = sa1100_translate_mctrl_wake_mask(sport->wake);
+
+	for (i = 0; i < UART_GPIO_MAX; i++) {
+		struct gpio_desc *g;
+		int irq;
+
+		if (!(wake & BIT(i)))
+			continue;
+
+		g = mctrl_gpio_to_gpiod(sport->gpios, i);
+		if (!g)
+			continue;
+
+		irq = gpiod_to_irq(g);
+		if (irq > 0) {
+			ret = enable_irq_wake(irq);
+			if (ret)
+				goto disable;
+		}
+
+		enabled |= BIT(i);
+	}
 
 	if (sport)
 		uart_suspend_port(&sa1100_reg, &sport->port);
 
 	return 0;
+
+ disable:
+	for (i = 0; i < UART_GPIO_MAX; i++)
+		if (enabled & BIT(i))
+			mctrl_gpio_disable_wake(sport->gpios, i);
+	return ret;
 }
 
 static int sa1100_serial_resume(struct platform_device *dev)
 {
 	struct sa1100_port *sport = platform_get_drvdata(dev);
+	unsigned int i, wake = sa1100_translate_mctrl_wake_mask(sport->wake);
+
+	for (i = 0; i < UART_GPIO_MAX; i++) {
+		struct gpio_desc *g;
+		int irq;
+
+		if (!(wake & BIT(i)))
+			continue;
+
+		g = mctrl_gpio_to_gpiod(sport->gpios, i);
+		if (!g)
+			continue;
+
+		irq = gpiod_to_irq(g);
+		if (irq > 0)
+			disable_irq_wake(irq);
+	}
 
 	if (sport)
 		uart_resume_port(&sa1100_reg, &sport->port);
@@ -845,6 +934,26 @@ static int sa1100_serial_add_one_port(struct sa1100_port *sport, struct platform
 		sport->gpios = NULL;
 	}
 
+	sport->xcvr_enable = devm_gpiod_get_optional(sport->port.dev,
+						     "xcvr-enable", GPIOD_ASIS);
+	if (IS_ERR(sport->xcvr_enable)) {
+		int err = PTR_ERR(sport->xcvr_enable);
+
+		dev_err(sport->port.dev, "failed to get xcvr gpio: %d\n",
+			err);
+
+		if (err == -EPROBE_DEFER)
+			return err;
+
+		sport->xcvr_enable = NULL;
+	}
+
+	sport->clk = devm_clk_get(sport->port.dev, NULL);
+	if (IS_ERR(sport->clk))
+		return PTR_ERR(sport->clk);
+
+	device_init_wakeup(sport->port.dev, !!sport->wake);
+
 	platform_set_drvdata(dev, sport);
 
 	return uart_add_one_port(&sa1100_reg, &sport->port);
diff --git a/drivers/tty/serial/serial_mctrl_gpio.c b/drivers/tty/serial/serial_mctrl_gpio.c
index 8855688a5b6c..a03b476e785b 100644
--- a/drivers/tty/serial/serial_mctrl_gpio.c
+++ b/drivers/tty/serial/serial_mctrl_gpio.c
@@ -385,5 +385,24 @@ void mctrl_gpio_disable_irq_wake(struct mctrl_gpios *gpios)
 }
 EXPORT_SYMBOL_GPL(mctrl_gpio_disable_irq_wake);
 
+int mctrl_gpio_enable_wake(struct mctrl_gpios *gpios, enum mctrl_gpio_idx gidx)
+{
+	int ret = -EINVAL;
+
+	if (gidx < UART_GPIO_MAX && gpios->irq[gidx])
+		ret = enable_irq_wake(gpios->irq[gidx]);
+
+	return ret;
+}
+EXPORT_SYMBOL_GPL(mctrl_gpio_enable_wake);
+
+void mctrl_gpio_disable_wake(struct mctrl_gpios *gpios,
+			     enum mctrl_gpio_idx gidx)
+{
+	if (gidx < UART_GPIO_MAX && gpios->irq[gidx])
+		disable_irq_wake(gpios->irq[gidx]);
+}
+EXPORT_SYMBOL_GPL(mctrl_gpio_disable_wake);
+
 MODULE_DESCRIPTION("Helpers for controlling modem lines via GPIO");
 MODULE_LICENSE("GPL");
diff --git a/drivers/tty/serial/serial_mctrl_gpio.h b/drivers/tty/serial/serial_mctrl_gpio.h
index fc76910fb105..07bec3aa2786 100644
--- a/drivers/tty/serial/serial_mctrl_gpio.h
+++ b/drivers/tty/serial/serial_mctrl_gpio.h
@@ -101,6 +101,17 @@ void mctrl_gpio_enable_irq_wake(struct mctrl_gpios *gpios);
  */
 void mctrl_gpio_disable_irq_wake(struct mctrl_gpios *gpios);
 
+/*
+ * Enable wakeup due to state change on the gpio
+ */
+int mctrl_gpio_enable_wake(struct mctrl_gpios *gpios, enum mctrl_gpio_idx gidx);
+
+/*
+ * Disable wakeup due to state change on the gpio
+ */
+void mctrl_gpio_disable_wake(struct mctrl_gpios *gpios,
+			     enum mctrl_gpio_idx gidx);
+
 #else /* GPIOLIB */
 
 static inline
@@ -160,6 +171,17 @@ static inline void mctrl_gpio_disable_irq_wake(struct mctrl_gpios *gpios)
 {
 }
 
+static inline int mctrl_gpio_enable_wake(struct mctrl_gpios *gpios,
+					 enum mctrl_gpio_idx gidx)
+{
+	return 0;
+}
+
+static inline void mctrl_gpio_disable_wake(struct mctrl_gpios *gpios,
+					   enum mctrl_gpio_idx gidx)
+{
+}
+
 #endif /* GPIOLIB */
 
 #endif
diff --git a/include/linux/clk-provider.h b/include/linux/clk-provider.h
index 4a537260f655..052be7d22f24 100644
--- a/include/linux/clk-provider.h
+++ b/include/linux/clk-provider.h
@@ -1306,6 +1306,44 @@ struct clk_hw *devm_clk_hw_register_composite_pdata(struct device *dev,
 		unsigned long flags);
 void clk_hw_unregister_composite(struct clk_hw *hw);
 
+/**
+ * struct clk_gpio - gpio gated clock
+ *
+ * @hw:		handle between common and hardware-specific interfaces
+ * @gpiod:	gpio descriptor
+ *
+ * Clock with a gpio control for enabling and disabling the parent clock
+ * or switching between two parents by asserting or deasserting the gpio.
+ *
+ * Implements .enable, .disable and .is_enabled or
+ * .get_parent, .set_parent and .determine_rate depending on which clk_ops
+ * is used.
+ */
+struct clk_gpio {
+	struct clk_hw	hw;
+	struct gpio_desc *gpiod;
+};
+
+#define to_clk_gpio(_hw) container_of(_hw, struct clk_gpio, hw)
+
+extern const struct clk_ops clk_gpio_gate_ops;
+struct clk *clk_register_gpio_gate(struct device *dev, const char *name,
+		const char *parent_name, struct gpio_desc *gpiod,
+		unsigned long flags);
+struct clk_hw *clk_hw_register_gpio_gate(struct device *dev, const char *name,
+		const char *parent_name, struct gpio_desc *gpiod,
+		unsigned long flags);
+void clk_hw_unregister_gpio_gate(struct clk_hw *hw);
+
+extern const struct clk_ops clk_gpio_mux_ops;
+struct clk *clk_register_gpio_mux(struct device *dev, const char *name,
+		const char * const *parent_names, u8 num_parents, struct gpio_desc *gpiod,
+		unsigned long flags);
+struct clk_hw *clk_hw_register_gpio_mux(struct device *dev, const char *name,
+		const char * const *parent_names, u8 num_parents, struct gpio_desc *gpiod,
+		unsigned long flags);
+void clk_hw_unregister_gpio_mux(struct clk_hw *hw);
+
 struct clk *clk_register(struct device *dev, struct clk_hw *hw);
 struct clk *devm_clk_register(struct device *dev, struct clk_hw *hw);
 
diff --git a/include/linux/ipaq-sleeve.h b/include/linux/ipaq-sleeve.h
new file mode 100644
index 000000000000..42352e942c3c
--- /dev/null
+++ b/include/linux/ipaq-sleeve.h
@@ -0,0 +1,36 @@
+#ifndef LINUX_IPAQ_SLEEVE_H
+#define LINUX_IPAQ_SLEEVE_H
+
+#include <linux/device.h>
+#include <linux/mod_devicetable.h>
+
+struct ipaq_option_device {
+	struct ipaq_option_id id;
+	const char *description;
+	struct device dev;
+};
+#define to_ipaq_option_device(x) container_of(x, struct ipaq_option_device, dev)
+
+struct ipaq_option_driver {
+	const struct ipaq_option_id *id_table;
+	struct device_driver driver;
+};
+
+extern struct bus_type ipaq_option_sleeve_bus;
+
+int ipaq_option_device_add(struct device *parent, struct ipaq_option_id id,
+			   const char *description);
+void ipaq_option_device_del(void);
+
+static inline int ipaq_option_driver_register(struct ipaq_option_driver *drv)
+{
+	drv->driver.bus = &ipaq_option_sleeve_bus;
+	return driver_register(&drv->driver);
+}
+
+static inline void ipaq_option_driver_unregister(struct ipaq_option_driver *drv)
+{
+	driver_unregister(&drv->driver);
+}
+
+#endif
diff --git a/include/linux/mod_devicetable.h b/include/linux/mod_devicetable.h
index 4338b1b4ac44..a7bd02606bb3 100644
--- a/include/linux/mod_devicetable.h
+++ b/include/linux/mod_devicetable.h
@@ -652,6 +652,16 @@ struct isapnp_device_id {
 	kernel_ulong_t driver_data;	/* data private to the driver */
 };
 
+/**
+ * struct ipaq_option_id - iPAQ sleeve option id
+ * @vendor: 16-bit vendor identifier
+ * @device: 16-bit device identifier
+ */
+struct ipaq_option_id {
+	__u16 vendor;
+	__u16 device;
+};
+
 /**
  * struct amba_id - identifies a device on an AMBA bus
  * @id: The significant bits if the hardware device ID
diff --git a/include/linux/platform_data/sa11x0-serial.h b/include/linux/platform_data/sa11x0-serial.h
index 8b79ab08af45..9ecd9611d90f 100644
--- a/include/linux/platform_data/sa11x0-serial.h
+++ b/include/linux/platform_data/sa11x0-serial.h
@@ -12,6 +12,13 @@
 struct uart_port;
 struct uart_info;
 
+enum {
+	SA11X0_WAKE_CTS = BIT(0),
+	SA11X0_WAKE_DCD = BIT(1),
+	SA11X0_WAKE_DSR = BIT(2),
+	SA11X0_WAKE_RI  = BIT(3),
+};
+
 /*
  * This is a temporary structure for registering these
  * functions; it is intended to be discarded after boot.
@@ -20,14 +27,14 @@ struct sa1100_port_fns {
 	void	(*set_mctrl)(struct uart_port *, u_int);
 	u_int	(*get_mctrl)(struct uart_port *);
 	void	(*pm)(struct uart_port *, u_int, u_int);
-	int	(*set_wake)(struct uart_port *, u_int);
+	unsigned wake[3];
 };
 
 #ifdef CONFIG_SERIAL_SA1100
-void sa1100_register_uart_fns(struct sa1100_port_fns *fns);
+void sa1100_register_uart_fns(const struct sa1100_port_fns *fns);
 void sa1100_register_uart(int idx, int port);
 #else
-static inline void sa1100_register_uart_fns(struct sa1100_port_fns *fns)
+static inline void sa1100_register_uart_fns(const struct sa1100_port_fns *fns)
 {
 }
 static inline void sa1100_register_uart(int idx, int port)
